var _g_MAIN_DOCUMENT_NAME;

function init3D(mainDocName) {
	_g_MAIN_DOCUMENT_NAME = mainDocName;
}

// @see http://blog.flexexamples.com/2008/03/11/returning-values-from-javascript-in-your-flex-applications-using-the-externalinterface-api/
function getNavigatorObject(keys) {
    var hash = {};
    var len = keys.length;
    for (var i=0; i<len; i++) {
        var key = keys[i];
        var value = navigator[key];
        hash[key] = value;
    }

    return hash;
}

var _g_ERROR='ERROR: ';
function createErrorMessage(err) {
	var msg = _g_ERROR + err.description;
	return msg;
}

var _g_MESSAGE='MSG:\n';
function showMessage(msg) {
	//DEBUG alert(_g_MESSAGE+msg);
	try
	{
	    window.status=message;
	}
	catch(err)
	{
	}
}

var _g_BACKGROUND_COLOR=null;
var _g_3DVIEWER=null;

// http://xkr.us/articles/dom/iframe-document/
function get3DViewer(id, controlID, bgColor) {
	var frameDoc;
	var frame = document.getElementById(id);
	if (frame == null) {
		var msg = 'get3DViewer::(frame==null)could not find frame on page with ID='+id;
		//DEBUG alert(msg);
		//return;
	}
	var doc = document.getElementById(controlID);
	if (doc != null) {
		_g_3DVIEWER = doc;
	} else {
		frameDoc = (frame.contentWindow || frame.contentDocument);
		if (frameDoc.document) frameDoc = frameDoc.document;
		_g_3DVIEWER = frameDoc.getElementById('SAS3DViewCtrl');
	}
	if (_g_3DVIEWER == null) {
		msg = 'get3DViewer::(3dviewer==null)could not find Active-X control on page';
		//DEBUG alert(msg);
	}
	if (bgColor != null) {
		_g_BACKGROUND_COLOR = bgColor;
		if (frameDoc != null) {
			frameDoc.body.style.backgroundColor = '#' + bgColor;
			//DEBUG alert('set frame background color to #'+bgColor);
		} else {
			frame.style.backgroundColor = '#' + bgColor;
			//DEBUG alert('set document background color to #'+bgColor);
		}
	}
	//DEBUG alert('frame:'+frame.nodeName+', viewer3D:'+_g_3DVIEWER.nodeName);
	
	return _g_3DVIEWER;
}
/* valid properties are:
	Animation		(false)
	FillPatterns	(false)
	FixtureLabels	(true)
	LineShapes		(false)
	ProductLabels	(true)
	SolidFixtures	(true)
	TextureMapping	(true)
	ToolTips		(true)

	NOTE: all values are true/false
*/
function setProperty(id, controlID, property, value) {

	var msg = '';
	if (property == 'Annotations') {
		msg = 'found bad property: ('+property+')';
		return msg;
	}
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		var returnCode = viewer3D.SetEnabled(property, value);
		msg = ' set-property:'+property+'='+viewer3D.GetEnabled(property)+' (rc:'+returnCode+')';
		if (returnCode) {
			alert('Error in changing property "'+property+'" in 3D Viewer (rc='+returnCode+')');
		}
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('setProperty: ' + msg);
	}
	return msg;
}
function setDecimalSeparator(id, controlID, value) {

	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		var returnCode = viewer3D.SetDecimalSeparator(value);
		msg = ' Set decimal separator to "'+value+'" (rc:'+returnCode+')';
		if (returnCode) {
			alert('Error in changing decimal separator to "'+value+'" in 3D Viewer (rc='+returnCode+')');
		}
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('setDecimalSeparator: ' + msg);
	}
	return msg;
}
function setLocalizedStrings(id, controlID, width, height, depth, facings, caps, nested, rotated, gap, pattern, node) {

	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		var returnCode = viewer3D.SetLocalizedStrings(width, height, depth, facings, caps, nested, rotated, gap, pattern, node);
		msg = ' Set localized strings (rc:'+returnCode+')';
		if (returnCode) {
			alert('Error in setting localized string in 3D Viewer (rc='+returnCode+')');
		}
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('setLocalizedStrings: ' + msg);
	}
	return msg;
}
/* valid color properties are:
	Background
	Selection
	Text
	TextBackground
	Fixture
	Subfixture
	Product
	ScannerPeg

	NOTE: all colors are BGR not in standard RGB form
*/
function setColor(id, controlID, property, value) {

	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		var returnCode = viewer3D.SetColor(property, value);
		msg = ' set-color for "'+property+'": '+viewer3D.GetColor(property)+' (rc:'+returnCode+')';
		if (returnCode) {
			alert('Error in changing color "'+property+' to '+value+'" in 3D Viewer (rc='+returnCode+')');
		}
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('setColor: ' + msg);
	}
	return msg;
}
/* valid values are:
	Select
	Rotate (default)
	Pan
	Zoom
	Light
	Walker
*/
function setMouseMode(id, controlID, value) {

	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		var returnCode = viewer3D.SetMouseMode(value);
		msg = ' mouse-mode:'+viewer3D.GetMouseMode()+' (rc:'+returnCode+')';
		if (returnCode) {
			alert('Error in mode to "'+value+'" in 3D Viewer (rc='+returnCode+')');
		}
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('setMouseMode: ' + msg);
	}
	return msg;
}

function getMouseMode(id, controlID)
{
	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;
	try
	{
		var mode = viewer3D.GetMouseMode();
		return mode;
	}
	catch (err)
	{
		msg = createErrorMessage(err);
		alert('getMouseMode: ' + msg);
	}
}
/* valid values are:
	Perspective (default)
	Oblique
	Orthographic
	Left
	Right
	Top
	Bottom
*/
function setProjection(id, controlID, value) {
	
	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;
	try {
		var returnCode = viewer3D.SetProjection(value);
		msg = ' projection:'+viewer3D.GetProjection()+' (rc:'+returnCode+')';
		if (returnCode) {
			alert('Error in changing projection to "'+value+'" in 3D Viewer (rc='+returnCode+')');
		}
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('setProjection: ' + msg);
	}
	return msg;
}
function getProjection(id, controlID)
{
	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		msg = viewer3D.GetProjection();
	} catch (err) {
		msg = createErrorMessage(err);
		alert('getProjection: ' + msg);
	}
	return msg;
}
/* valid values are:
	NoSelect
	SingleSelect
	MultiSelectTouched
	MultiSelectEnclosed (default)
*/
function setSelectionMode(id, controlID, value) {

	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		var returnCode = viewer3D.SetSelectionMode(value);
		msg = ' selection-mode:'+viewer3D.GetSelectionMode()+' (rc:'+returnCode+')';
		if (returnCode) {
			alert('Error in changing selection mode to "'+value+'" in 3D Viewer (rc='+returnCode+')');
		}
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('setSelectionMode: ' + msg);
	}
	return msg;
}
/* valid values are:
	Frame
	Block
*/
function setViewMode(id, controlID, value) {

	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		var returnCode = viewer3D.SetViewMode(value);
		msg = ' view-mode:'+viewer3D.GetViewMode()+' (rc:'+returnCode+')';
		if (returnCode) {
			alert('Error in changing view mode to "'+value+'" in 3D Viewer (rc='+returnCode+')');
		}
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('setViewMode: ' + msg);
	}
	return msg;
}
/* valid values are:
	None
	TopToTop
	TopToBottom
	BottomToBottom
	GroundToTop
	NotchNumbers
*/
function setCrossViewLabelMode(id, controlID, value) {

	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		var returnCode = viewer3D.SetCrossViewLabelMode(value);
		msg = ' cross-view-label-mode:'+viewer3D.GetCrossViewLabelMode()+' (rc:'+returnCode+')';
		if (returnCode) {
			alert('Error in changing cross view label mode to "'+value+'" in 3D Viewer (rc='+returnCode+')');
		}
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('setCrossViewLabelMode: ' + msg);
	}
	return msg;
}
function selectByID(id, controlID, value, extendSelection) {
	_changeSelectedObject(id, controlID, value, extendSelection, true);
}
function clearAll(id, controlID)
{
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;
	try
	{
		viewer3D.SetSelectedID('', false);
	}
	catch(err)
	{
		msg = createErrorMessage(err);
		alert('clearAll: ' = msg);
	}
}

function unselectByID(id, controlID, value) {
	return _changeSelectedObject(id, controlID, value, false, false);
}
function _changeSelectedObject(id, controlID, value, extendSelection, selectIt) {

	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		// clear all existing selections first
		if (selectIt && ! extendSelection) {
			var returnCode = viewer3D.SetSelectedID('', false);
		}
		var returnCode = viewer3D.SetSelectedID(value, selectIt);

		// verify it was not selected
		var wasSelected = false;
		var numSelected = viewer3D.GetNumSelections();
		for (var i=0; i<numSelected; i++) {
			var selectedID = viewer3D.GetSelectedID(i);
			if (value == selectedID) {
				wasSelected = true;
				break;
			}
		}
		var errorFound = 0;
		if (selectIt && ! wasSelected) {
			errorFound = 1;
		} else if (!selectIt && wasSelected) {
			errorFound = 2;
		}
		if (returnCode || errorFound > 0) {
			msg = 'Error (code='+errorFound+') '+(selectIt ? 'selecting' : 'unselecting')+' ID "'+value+'" in 3D Viewer (rc='+returnCode+')';
			/*alert(msg);*/
		}
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		/*alert(msg);*/
	}
	return msg;
}
function print3DView(id, controlID) {

	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		var returnCode = viewer3D.Print();
		msg = ' print (rc:'+returnCode+')';
		if (returnCode) {
			alert('Error in printing 3D View (rc='+returnCode+')');
		}
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('print3DView: ' + msg);
	}
	return msg;
}

function drill(id, controlID, selectedID)
{
	var viewer3D = get3DViewer(id, controlID);
	if (viewer3D != null)
	{
		if (selectedID != null)
		{
			viewer3D.DrillDown(selectedID);
		}
		else
		{
			viewer3D.DrillUp();
		}
	}
}
function saveAsImage(id, controlID) {

	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try 
	{
	   var returnCode = viewer3D.SaveAsImage('', 0, 0);
	} 
	catch (err) 
	{
		msg = createErrorMessage(err);
		alert('saveAsImage: ' + msg);
	}
	
	return msg;
}
function resetView(id, controlID) {

	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		var returnCode = viewer3D.ResetView();
		msg = ' reset view (rc:'+returnCode+')';
		if (returnCode) {
			alert('Error in reseting 3D View');
		}
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('resetView: ' + msg);
	}
	return msg;
}


function getHoldDisplay(id, controlID)
{
	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;
	try
	{
		var hold = viewer3D.GetHoldDisplay();
		return hold;
	}
	catch (err)
	{
		msg = createErrorMessage(err);
		alert('getHoldDisplay: ' + msg);
	}
}

function setHoldDisplay(id, controlID, value) {

	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		var returnCode = viewer3D.SetHoldDisplay(value);
		msg = ' hold-display:'+viewer3D.GetHoldDisplay()+' (rc:'+returnCode+')';
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('setHoldDisplay: ' + msg);
	}
	return msg;
}
function loadPlanogram(id, controlID, planogramX3D) {

	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		/*setHoldDisplay(id, controlID, true);*/
		msg += _loadPlanogramIntoViewer(viewer3D, planogramX3D);
		/*setHoldDisplay(id, controlID, false);*/
	} catch (err) {
		msg = createErrorMessage(err);
		alert('loadPlanogram: ' + msg);
	}
	showMessage(msg);
	return msg;
}
function setImageURL(id, controlID, url) {
	
	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (viewer3D == null) return;
	
	try {
		var returnCode = viewer3D.SetTextureImagePath(url);
		msg = ' SetTextureImagePath:'+viewer3D.GetTextureImagePath()+' (rc:'+returnCode+')';
		//alert(msg);
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('setImageURL: ' + msg);
	}
	return msg;
}

function setShapeURL(id, controlID, url) {

	var msg = '';
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

	try {
		var returnCode = viewer3D.SetLineShapePath(url);
		msg = ' SetTextureImagePath:'+viewer3D.GetLineShapePath()+' (rc:'+returnCode+')';
		showMessage(msg);
	} catch (err) {
		msg = createErrorMessage(err);
		alert('setShapeURL: ' + msg);
	}
	return msg;
}

function setBackgroundColor(id, controlID, bgColor) {

	//DEBUG alert('setBackgroundColor: id='+id+' bgColor='+bgColor);
	var msg = '';
	if (bgColor != null) {
		var viewer3D = get3DViewer(id, controlID, bgColor);
		if (null == viewer3D) return;

		try {
			msg += setColor(id, controlID, 'Background', '0x'+bgColor);
		} catch (err) {
			msg = createErrorMessage(err);
			alert('setBackgroundColor: ' + msg);
		}
		showMessage(msg);
	}
}
function setAllColors(id, controlID, colors) {

	//DEBUG alert('setAllColors: id='+id+' colors='+colors);
	var msg = '';
	if (colors != null) {
		var viewer3D = get3DViewer(id, controlID);
		if (null == viewer3D) return;
	
		try {
			var colorsHash = _getColorsAsHash(colors);
			if (colorsHash.background != null) {
				msg += setColor(id, controlID, 'Background', colorsHash.background);
			}
			if (colorsHash.text != null) {
				msg += setColor(id, controlID, 'Text', colorsHash.text);
			}
			if (colorsHash.selection != null) {
				msg += setColor(id, controlID, 'Selection', colorsHash.selection);
			}
			if (colorsHash.fixture != null) {
				msg += setColor(id, controlID, 'Fixture', colorsHash.fixture);
			}
			if (colorsHash.subfixture != null) {
				msg += setColor(id, controlID, 'Subfixture', colorsHash.subfixture);
			}
			if (colorsHash.product != null) {
				msg += setColor(id, controlID, 'Product', colorsHash.product);
			}
			if (colorsHash.pegs != null) {
				msg += setColor(id, controlID, 'ScannerPeg', colorsHash.pegs);
			}
		} catch (err) {
			msg = createErrorMessage(err);
			alert('setAllColors: ' + msg);
		}
		showMessage(msg);
	}
	return msg;
}

function onDrag(cid, controlID, viewer3D, modifierState) {
    var msg = '';
    try {
        var selectedIDs = new Array();
        var numSelected = viewer3D.GetNumSelections();
        for (var i = 0; i < numSelected; i++) {
            id = viewer3D.GetSelectedID(i);
            selectedIDs.push(id);
        }
        
        if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
            document.getElementById(_g_MAIN_DOCUMENT_NAME).onViewerDrag(cid, controlID, selectedIDs, modifierState);
        }
    } catch (err) {
        msg = createErrorMessage(err);
        alert('onDrag: ' + msg);
    }
}
function onDrop(cid, controlID, viewer3D, modifierState) {
    var msg = '';
    try {
		
        var selectedIDs = new Array();
        var numSelected = viewer3D.GetNumSelections();
        for (var i = 0; i < numSelected; i++) {
			id = viewer3D.GetSelectedID(i);
            selectedIDs.push(id);
        }

        if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
            document.getElementById(_g_MAIN_DOCUMENT_NAME).onViewerDrop(cid, controlID, selectedIDs,modifierState);
        }
    } catch (err) {
        msg = createErrorMessage(err);
        alert('onDrop: ' + msg);
    }
	return false;
}
function onDrillDown(cid, controlID, viewer3D, evt)
{
    var msg = '';
    try {
		var id;
        var selectedIDs = new Array();
		selectedIDs.push(evt);
        if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
            document.getElementById(_g_MAIN_DOCUMENT_NAME).onDrillDown(cid, controlID, selectedIDs);
        }
    } catch (err) {
        msg = createErrorMessage(err);
        alert('onDrillDown: ' + msg);
    }
}

function onDrillUp(cid, controlID, viewer3D)
{
    var msg = '';
    try {
        var selectedIDs = new Array();
        var numSelected = viewer3D.GetNumSelections();
        for (var i = 0; i < numSelected; i++) {
            id = viewer3D.GetSelectedID(i);
            selectedIDs.push(id);
        }

        if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
            document.getElementById(_g_MAIN_DOCUMENT_NAME).onDrillUp(cid, controlID, selectedIDs);
        }
    } catch (err) {
        msg = createErrorMessage(err);
        alert('onDrillUp: ' + msg);
    }
}

function onKeyPressedEvent(_id, controlID, viewer3D,keyCode,bShift,bCtrl,bAlt) 
{
	 try 
	 {
        if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) 
        {
            document.getElementById(_g_MAIN_DOCUMENT_NAME).onKeyPressedEvent(_id, controlID,keyCode,bShift,bCtrl,bAlt);
        }
    } 
    catch (err) 
    {
        msg = createErrorMessage(err);
        alert('onKeyPressedEvent: ' + msg);
    }
}

function getSelections(_id, _controlId)
{
	try
	{
		var selectedIDs = new Array();
		
		var viewer3D = get3DViewer(_id, _controlId);
		if (null == viewer3D) return null;
		var numSelected = viewer3D.GetNumSelections();
		
		for (var i=0; i<numSelected; i++) {
			id = viewer3D.GetSelectedID(i);
			selectedIDs.push(id);
		}
		
		return selectedIDs;
		
	}
	catch(err)
	{
		return null;
	}
		
}

function selectedIn3D(_id, controlID, viewer3D) {

	var msg = '';
	try {
		var selectedIDs = new Array();
		var numSelected = viewer3D.GetNumSelections();
		for (var i=0; i<numSelected; i++) {
			id = viewer3D.GetSelectedID(i);
			selectedIDs.push(id);
		}
		//DEBUG alert('selected #'+numSelected+' IDs: '+selectedIDs.toString());

		if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
			document.getElementById(_g_MAIN_DOCUMENT_NAME).selectedIDs(_id, controlID, selectedIDs);
		}
	} catch (err) {
		msg = createErrorMessage(err);
		alert('selectedIn3D: ' + msg);
	}
}
function onBitmapUpdateEvent(id, controlID, viewer3D)
{
	var msg = '';
	try {
		if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
			document.getElementById(_g_MAIN_DOCUMENT_NAME).bitmapUpdateEvent(id, controlID);
		}
	} catch (err) {
		msg = createErrorMessage(err);
		alert('onBitmapUpdateEvent: ' + msg);
	}
}

function handleEvents3D(id, controlID, viewer3D) {
	// @see http://devguru.com/technologies/javascript/11485.asp
	// we only support internet explorer (since we're using active X), so no stuff for FF or Safari
	if (viewer3D.detachEvent) {
		viewer3D.detachEvent('OnSelectionChanged', selectedIn3D, false);
		viewer3D.detachEvent('OnDragEvent', onDrag, false);
		viewer3D.detachEvent('OnDropEvent', onDrop, false);
		viewer3D.detachEvent('OnDrillDownEvent', onDrillDown, false);
		viewer3D.detachEvent('OnDrillUpEvent', onDrillUp, false);
		viewer3D.detachEvent('OnSetFocusEvent', onSetFocusEvent, false);
		viewer3D.detachEvent('OnKillFocusEvent', onKillFocusEvent, false);
		viewer3D.detachEvent('OnFrameRedrawn', onFrameRedrawn, false);
		viewer3D.detachEvent('OnKeyPressedEvent',onKeyPressedEvent, false);
		viewer3D.detachEvent('OnContextMenuEvent', onContextMenuEvent, false);
		viewer3D.detachEvent('OnMouseButtonEvent', onMouseButtonEvent, false);
	}
	if (viewer3D.attachEvent) {
		viewer3D.attachEvent('OnSelectionChanged', function(){selectedIn3D(id, controlID, viewer3D)}, false);
		viewer3D.attachEvent('OnDragEvent', function(modifierState){onDrag(id, controlID, viewer3D, modifierState)}, false);
		viewer3D.attachEvent('OnDropEvent', function(modifierState){onDrop(id, controlID, viewer3D, modifierState)}, false);
		viewer3D.attachEvent('OnDrillDownEvent', function(evt){onDrillDown(id, controlID, viewer3D, evt)}, false);
		viewer3D.attachEvent('OnDrillUpEvent', function(){onDrillUp(id, controlID, viewer3D)}, false);

		viewer3D.attachEvent('OnSetFocusEvent', function(){onSetFocusEvent(id, controlID, viewer3D)}, false);
		viewer3D.attachEvent('OnKillFocusEvent', function(){onKillFocusEvent(id, controlID, viewer3D)}, false);
		viewer3D.attachEvent('OnFrameRedrawn', function(){onFrameRedrawn(id, controlID, viewer3D)}, false);
		viewer3D.attachEvent('OnKeyPressedEvent', function(keyCode,bShift,bCtrl,bAlt){onKeyPressedEvent(id,controlID,viewer3D,keyCode,bShift,bCtrl,bAlt)}, false);
		viewer3D.attachEvent('OnContextMenuEvent', function(winID, evtID){onContextMenuEvent(id, controlID, viewer3D, winID, evtID)}, false);
		viewer3D.attachEvent('OnBitmapUpdateEvent', function(){onBitmapUpdateEvent(id, controlID, viewer3D)}, false);
		viewer3D.attachEvent('OnMouseButtonEvent', function(mask, upDown){ onMouseButtonEvent(id, controlID, mask, upDown)}, false);
				viewer3D.attachEvent('OnTextAnnotationEvent', 
				function(annoID, annoText, annoColor, x, y) { onTextAnnotationEvent(id, controlID, viewer3D, annoID, annoText, annoColor, x, y)}, false);
		viewer3D.attachEvent('OnLineAnnotationEvent', 
				function(annoID, startX, startY, endX, endY) { onLineAnnotationEvent(id, controlID, viewer3D, annoID, startX, startY, endX, endY)}, false);
	}
}
// NOTE: all colors are BGR not in standard RGB form
function setDefaults3D(id, controlID, bgColor, colors, showWireframe, showLabels, showImages, 
						planogramX3D, registerEvents, readOnly) {

	/* DEBUG 
	alert('setDefaults3D:'
		+' id='+id
		+' bgColor=#'+bgColor
		+' colors='+colors
		+' showFrame='+showWireframe
		+' showLabels='+showLabels
		+' showImages='+showImages
		+' X3D length='+planogramX3D.length);
	 DEBUG */

	var msg = '';
	var viewer3D = get3DViewer(id, controlID, bgColor);
	if (null == viewer3D) return;

	if (registerEvents == true)
		handleEvents3D(id, controlID,viewer3D);

	try {
		//msg += setHoldDisplay(id, controlID, true);
		msg += setProperty(id, controlID, "CachedBitmapImage", true);
		msg += setAllColors(id, controlID, colors);

		if (showWireframe) {
			msg += setViewMode(id, controlID, 'Frame');				// Frame, Block
		} else {
			msg += setViewMode(id, controlID, 'Block');				// Frame, Block
		}

		msg += setSelectionMode(id, controlID, 'MultiSelectEnclosed');	// NoSelect, SingleSelect, MultiSelectTouched, MultiSelectEnclosed (default)
		msg += setProjection(id, controlID, 'Perspective');			// Perspective (default), Oblique, Orthographic, Left, Right, Top, Bottom
		msg += setMouseMode(id, controlID, 'Select'); 					// Select, Rotate (default), Pan, Zoom, Light, Walker, MoveObj

		// Animation, FillPatterns, FixtureLabels, LightModel, LineShapes, ProductLabels, SolidFixtures, TextureMapping, TextureColorBlend, ToolTips
		msg += setProperty(id, controlID, 'ProductLabels', showLabels);
		msg += setProperty(id, controlID, 'TextureMapping', showImages);
		msg += setProperty(id, controlID, 'ToolTips', true);
		msg += setProperty(id, controlID, 'PegHoles', false);
		msg += setProperty(id, controlID, 'ContextMenu', false);
		if (readOnly)
		{
			msg += setProperty(id, controlID, 'ReadOnly', readOnly);
		}
		msg += _loadPlanogramIntoViewer(viewer3D, planogramX3D);
		

		/*msg += setHoldDisplay(id, controlID, false);*/
		} catch (err) {
		msg = createErrorMessage(err);
		alert('setDefaults3D: ' + msg);
	}
	showMessage(msg);
	return msg;
}
function _loadPlanogramIntoViewer(viewer3D, planogramX3D) {
	var msg = '';
	if (planogramX3D != null) {
		var planogramXML = _getXML(planogramX3D);
		var xmlLength = planogramXML.length * 2;
		//DEBUG alert('in loadPlanogram length:'+xmlLength);
		var rc1 = viewer3D.StartX3DString(xmlLength);
		var rc2 = viewer3D.AddX3DString(planogramXML);
		var rc3 = viewer3D.EndX3DString();
		msg = ' loadPlanogram (rc1='+rc1+' rc2='+rc2+' rc3='+rc3+')';
	} else {
		msg = ' planogramX3D is empty';
	}
	return msg;
}
function _getXML(planogramX3D) {
	var xml = planogramX3D.replace(/UTF-8/, 'UTF-16');
	return xml;
}
function _getColorsAsHash(colors) {

	// DEBUG var msg = 'Colors:\n';
	var colorsHash = {};
	colors = colors.replace(/[{}]/g, '');
	var splitColors = colors.split(',');
	for (var i=0; i<splitColors.length; i++) {
	    var oneColor = splitColors[i].split(':');
	    if (oneColor.length == 2) {
	        var key = oneColor[0];
	        var value = oneColor[1];
	        if (key != '' && value != '') {
	        	// override the background color to match the frame background color
	        	if (key.match(/background/i) != null) {
	        		if (_g_BACKGROUND_COLOR != null) {
	        			value = _g_BACKGROUND_COLOR;
	        		}
	        	}
	            colorsHash[key] = '0x' + value;
	            // DEBUG msg += key+'='+colorsHash[key]+' ';
	        }
	    }
	}
	return colorsHash;
}
function registerOnInitComplete(id, controlID)
{
	var frame = document.getElementById(id);
	var viewer3D = document.getElementById(controlID);
	if (viewer3D == null) {
		alert("can't get viewer");
		return;
	}
	alert('here');
	// @see http://devguru.com/technologies/javascript/11485.asp
	// Firefox & Safari
	if (viewer3D.addEventListener) {
		viewer3D.addEventListener('oninitcompleteevent', tellMe, false);

	// internet explorer
	} else if (viewer3D.attachEvent) {
		viewer3D.attachEvent("oninitcompleteevent", tellMe, false);
		
		} else {
    	viewer3D.OnInitCompleteEvent = function() {
    		tellMe();
    	};
	}
}
function tellMe(id, controlID)
{
	if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) 
	{
		var frame = document.getElementById(id);
		if (frame == null) {
			return;
		}
		var viewer3D = document.getElementById(controlID);
		if (viewer3D == null) {
			return;
		}
		// @see http://devguru.com/technologies/javascript/11485.asp
		// Firefox & Safari
		if (viewer3D.removeEventListener) {
			viewer3D.removeEventListener('oninitcompleteevent', tellMe, false);
	
		// internet explorer
		} else if (viewer3D.detachEvent) {
			viewer3D.detachEvent("oninitcompleteevent", tellMe, false);
			
			}
	
		document.getElementById(_g_MAIN_DOCUMENT_NAME).onInitComplete(id, controlID);
	}
}

function getSelectedValue(id, controlID, index, key) 
{
    var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return null;

    var value = viewer3D.GetSelectedValue(index, key);
    return value;
}

function getXYZ(id, controlID, index)
{
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return null;

    var x = viewer3D.GetSelectedValue(index, 'X');
    var y = viewer3D.GetSelectedValue(index, 'Y');
    var z = viewer3D.GetSelectedValue(index, 'Z');
    var value = [x,y,z];
    return value;
}
function initDragDrop(id, controlID, selectedID, width, height, depth) 
{
    var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

    viewer3D.InitDragDrop(selectedID, width, height, depth);
}

function exitDragDrop(id, controlID) {
    var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return;

    viewer3D.ExitDragDrop();
}

function onSetFocusEvent(id, controlID, viewer3D)
{
	//if (_g_FATAL_ERROR) return;
	var msg = '';
	try {
		if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
			document.getElementById(_g_MAIN_DOCUMENT_NAME).onSetFocusEvent(id, controlID);
		}
	} catch (err) {
		msg = createErrorMessage(err);
		alert('onSetFocusEvent->' + msg);
	}
}

function onKillFocusEvent(id, controlID, viewer3D)
{
//	if (_g_FATAL_ERROR) return;
	var msg = '';
	try {
		if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
			document.getElementById(_g_MAIN_DOCUMENT_NAME).onKillFocusEvent(id, controlID );
		}
	} catch (err) {
		msg = createErrorMessage(err);
		//alert('onKillFocusEvent->' + msg);
	}
}

/////////////////////////
// world coord methods
/////////////////////////
function getWorldCoordAtPoint(id, controlID, x, y)
{
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return null;

	var dp = viewer3D.GetWorldCoordAtPoint(x, y);
	var coords = [dp.x, dp.y, dp.z];
	return coords;
}

function getObjectAtPoint(id, controlID, x, y)
{
	var viewer3D = get3DViewer(id, controlID);
	var id = viewer3D.GetObjectIDAtPoint(x,y);
	return id;
}

function getBitmapImage(id, controlID)
{
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return null;
	// false = no base64, true=base64
	var bitmap = viewer3D.GetBitmapImage(0,0, false);
	return bitmap;
}
function onFrameRedrawn(id, controlID, viewer3D)
{
	//if (_g_FATAL_ERROR) return;
	var msg = '';
	try {
		if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
			document.getElementById(_g_MAIN_DOCUMENT_NAME).onFrameRedrawn(id, controlID);
		}
	} catch (err) {
		msg = createErrorMessage(err);
		alert('onFrameRedrawn->' + msg);
	}
}
///////////////////////////////////////////////////
// printing support
///////////////////////////////////////////////////
function print3D(id, controlID, usePrintDialog)
{
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return null;
	viewer3D.Print(usePrintDialog);
}
function addPrintSegment(id, controlID, segment)
{
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return null;
	viewer3D.AddPrintSegment(segment);
}

function deletePrintSegments(id, controlID)
{
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return null;
	viewer3D.DeletePrintSegments();
}

function setPrintOption(id, controlID, name, value)
{
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return null;
	viewer3D.SetPrintOption(name, value);
	//option.name, option.value);
}

function setHeaderFooter(id, controlID, options)
{
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return null;
	viewer3D.SetHeaderFooter(options.isHeader, options.text, 
							options.isHTML, options.fontSize, options.fontBold, 
							options.fontItalic, options.fontName, options.horizontalTextAlign);
}

function setPrintMargins(id, controlID, options)
{
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return null;
	viewer3D.SetPrintMargins(options.marginLeftPts, options.marginRightPts, options.marginTopPts, options.marginBottomPts, 
							options.headerMarginPts, options.footerMarginPoints);
}

function getPixelDimensions(id, controlID, xval, yval, zval)
{
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return null;
	var dim =  viewer3D.ConvertSizeToPixels(xval, yval, zval);
	var coords = [dim.x, dim.y, dim.z];
	
	return coords;
}

function getBoundingBox(id, controlID, moniker, centerOrSize)
{
	var viewer3D = get3DViewer(id, controlID);
	if (null == viewer3D) return null;
	var dp = viewer3D.GetBoundingBox(moniker, centerOrSize);
	var box = [dp.x, dp.y, dp.z];
	return box;
}


// control has:
// HRESULT OnContextMenuEvent(short winID, BSTR ID)
function onContextMenuEvent(id, controlID, viewer3D, winID, evtID)
{
    var msg = '';
    try {

        if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
            document.getElementById(_g_MAIN_DOCUMENT_NAME).onContextMenuEvent(id, controlID, winID, evtID);
        }
    } catch (err) {
        msg = createErrorMessage(err);
        alert('onContextMenuEvent: ' + msg);
    }
	return false;

}

function get3DVersion()
{
	// use the preload version of the viewer (used for the version check), so that we're guaranteed to have it available
	var viewer3D = document.getElementById('SAS3DViewerPreload');
	if (null == viewer3D) return null;
	var version = viewer3D.GetVersion();
	return version;
}
// from http://developer.apple.com/internet/webcontent/examples/styley_source.html
function setStyleById(i, p, v)
{
	var n = document.getElementById(i);
	if (n == null) alert('Document element missing.  Please contact your sysadmin to ensure you have the most current html');
	n.style[p] = v;
}

function coverUpControl(id, x,y,w,h)
{
	
	setStyleById(id, 'left', x);
	setStyleById(id, 'top', y);
	setStyleById(id, 'width', w);
	setStyleById(id, 'height', h);
	
	setStyleById(id, 'opacity', 0.0);
}

function getBaseURL()
{
	return document.location.href;
}

function onMouseButtonEvent(id, controlID, mask, upDown) // up = true, down=false
// masks are:
// MK_LBUTTON 0x0001
// MK_RBUTTON 0x0002
// MK_SHIFT   0x0004
// MK_CONTROL 0x0008
// MK_MBUTTON 0x0010
{
   var msg = '';
    try {

        if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
            document.getElementById(_g_MAIN_DOCUMENT_NAME).onViewerMouseButtonEvent(id, controlID, mask, upDown);
        }
    } catch (err) {
        msg = createErrorMessage(err);
        alert('onMouseButtonEvent: ' + msg);
    }
	return false;

}
function onTextAnnotationEvent(id, controlID, viewer3D, annoID, annoText, annoColor, x, y)
{
 var msg = '';
    try {

        if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
            document.getElementById(_g_MAIN_DOCUMENT_NAME).onTextAnnotationEvent(id, controlID, annoID, annoText, annoColor, x, y);
        }
    } catch (err) {
        msg = createErrorMessage(err);
        alert('onTextAnnotationEvent: ' + msg);
    }
	return false;
}

function onLineAnnotationEvent(id, controlID, viewer3D, annoID, startX, startY, endX, endY)
{
	var msg = '';
    try {

        if (document.getElementById(_g_MAIN_DOCUMENT_NAME) != null) {
            document.getElementById(_g_MAIN_DOCUMENT_NAME).onLineAnnotationEvent(id, controlID, annoID, startX, startY, endX, endY);
        }
    } catch (err) {
        msg = createErrorMessage(err);
        alert('onLineAnnotationEvent: ' + msg);
    }
	return false;
}
function getFontInfo(id, controlID, objID)
{
	var viewer3D = get3DViewer(id, controlID);
	if (viewer3D == null) // uh oh
		return; // die silently
	var fontInfo = viewer3D.GetFont(objID);
	var bs = {'Name':fontInfo.Name, 'Size':fontInfo.Size, 'Italic':fontInfo.Italic, 'Bold':fontInfo.Bold};
	return bs;
}

function unloadControl(id, controlID)
{
	try
	{
	   var viewer3D=get3DViewer(id, controlID);
	   if (viewer3D == null) return;
	   viewer3D.parentNode.removeChild(viewer3D);
	   delete viewer3D;
	}
	catch(err)
	{
	   msg = createErrorMessage(err);
	   alert("unloadControl failed for id= " + id +"; controlID=" + controlID + "\n" + msg);
	}
}